/* midifile - Decompiled by JODE
 * Visit http://jode.sourceforge.net/
 */
import java.io.File;
import java.io.IOException;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MetaEventListener;
import javax.sound.midi.MetaMessage;
import javax.sound.midi.MidiEvent;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Receiver;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.Track;
import javax.sound.midi.Transmitter;

import com.cycling74.max.Atom;
import com.cycling74.max.MaxObject;
import com.cycling74.max.MaxSystem;

public class midifile extends MaxObject implements Receiver, MetaEventListener
{
    private Sequence sequence = null;
    private Sequencer sequencer = null;
    private Transmitter transmitter = null;
    private File fp = null;
    private Track[] tracks = null;
    private int originalNumTracks = 1;
    private int numTracks = 2;
    private int def_duration = 250;
    private int def_channel = 0;
    private int def_velocity = 60;
    private static final int MAIN_OUTLET = 0;
    private static final int DUMP_OUTLET = 1;
    private static final int BANG_OUTLET = 3;
    private static final int INFO_OUTLET = 2;
    private boolean ignoreTempoChanges = false;
    private boolean ignoreNoteOffVelocity = true;
    private boolean verbose = false;
    private int[][] recordState = null;
    
    public void version() {
	post("midifile Version 3.0.1, by John MacCallum.\nCopyright (c) 2006-7 Regents of the University of California.  All rights reserved.");
    }
    
    public midifile(Atom[] atoms) {
	if (atoms.length > 0)
	    numTracks = originalNumTracks = atoms[0].getInt() + 1;
	if (atoms.length > 1)
	    def_duration = atoms[1].toInt();
	if (atoms.length > 2)
	    def_velocity = atoms[2].toInt();
	if (atoms.length > 3)
	    def_channel = atoms[3].toInt();
	recordState = new int[numTracks][16];
	int[] is = new int[numTracks - 1];
	String[] strings = new String[numTracks - 1];
	for (int i = 0; i < numTracks - 1; i++) {
	    is[i] = 15;
	    strings[i]
		= new StringBuilder().append("Track ").append(i + 1).append
		      (" midi input").toString();
	}
	declareInlets(is);
	declareOutlets(new int[] { 15, 15, 8, 15 });
	createInfoOutlet(false);
	setInletAssist(strings);
	setOutletAssist(new String[] { "Playback", "Dump",
				       "Bang when done playing or dumping",
				       "Information about the midifile" });
	initSequence();
	version();
    }
    
    public void ignoreTempoChanges(int i) {
	if (i == 0)
	    ignoreTempoChanges = false;
	else
	    ignoreTempoChanges = true;
    }
    
    public void list(Atom[] atoms) {
	if (sequencer.isRunning())
	    error
		("midifile: can't add notes to sequence while it is being played");
	else
	    addEventToTrack(atoms, getInlet() + 1);
    }
    
    public void addEventToTrack(Atom[] atoms) {
	if (atoms[0].toInt() >= numTracks)
	    error(new StringBuilder().append
		      ("midifile: the sequence only has ").append
		      (numTracks).append
		      (".  Can't add event to track number ").append
		      (atoms[0].toInt()).toString());
	else {
	    Atom[] atoms_0_ = new Atom[atoms.length - 1];
	    for (int i = 0; i < atoms_0_.length; i++)
		atoms_0_[i] = atoms[i + 1];
	    addEventToTrack(atoms_0_, atoms[0].toInt());
	}
    }
    
    public void addEventToTrack(Atom[] atoms, int i) {
	int i_1_ = atoms.length > 1 ? atoms[1].toInt() : 60;
	int i_2_ = atoms.length > 2 ? atoms[2].toInt() : def_velocity;
	int i_3_ = atoms.length > 3 ? atoms[3].toInt() : def_channel;
	int i_4_ = atoms.length > 4 ? atoms[4].toInt() : def_duration;
	int i_5_ = i_2_ > 0 ? 144 : 128;
	long l = atoms[0].toLong() * 1000L;
	long l_6_ = l + (long) (i_4_ * 1000);
	long l_7_;
	long l_8_;
	if (ignoreTempoChanges) {
	    l_7_ = (long) (atoms[0].toDouble() / 500.0
			   * (double) sequence.getResolution());
	    l_8_ = (long) ((double) l_7_
			   + ((double) i_4_ / 500.0
			      * (double) sequence.getResolution()));
	} else {
	    sequencer.setMicrosecondPosition(l);
	    l_7_ = sequencer.getTickPosition();
	    sequencer.setMicrosecondPosition(l_6_);
	    l_8_ = sequencer.getTickPosition();
	}
	MidiEvent midievent = createNoteEvent(i_5_, i_3_, i_1_, i_2_, l_7_);
	MidiEvent midievent_9_ = createNoteEvent(128, i_3_, i_1_, 0, l_8_);
	tracks[i].add(midievent);
	tracks[i].add(midievent_9_);
    }
    
    private static MidiEvent createNoteEvent(int i, int i_10_, int i_11_,
					     int i_12_, long l) {
	ShortMessage shortmessage = new ShortMessage();
	try {
	    shortmessage.setMessage(i, i_10_, i_11_, i_12_);
	} catch (InvalidMidiDataException invalidmididataexception) {
	    invalidmididataexception.printStackTrace();
	}
	return new MidiEvent(shortmessage, l);
    }
    
    public void setText(Atom[] atoms) {
	int i = atoms[0].toInt();
	String string = new String();
	for (int i_13_ = 0; i_13_ < atoms.length - 1; i_13_++)
	    string = string.concat(new StringBuilder().append
				       (atoms[i_13_ + 1].toString()).append
				       (" ").toString());
	byte[] is;
	try {
	    is = string.getBytes("US-ASCII");
	} catch (Exception exception) {
	    exception.printStackTrace();
	    error("midifile: couldn't encode text.");
	    return;
	}
	addMetaEvent(1, is, i);
    }
    
    public void addMetaEvent(Atom[] atoms) {
	byte[] is = new byte[atoms.length - 2];
	int i = atoms[1].toInt();
	for (int i_14_ = 0; i_14_ < is.length; i_14_++)
	    is[i_14_] = atoms[i_14_ + 2].toByte();
	addMetaEvent(atoms[0].toInt(), is, i);
    }
    
    private void addMetaEvent(int i, byte[] is, int i_15_) {
	int i_16_ = is.length;
	sequencer.setMicrosecondPosition((long) (i_15_ * 1000));
	long l = sequencer.getTickPosition();
	MetaMessage metamessage = new MetaMessage();
	try {
	    metamessage.setMessage(i, is, i_16_);
	} catch (InvalidMidiDataException invalidmididataexception) {
	    invalidmididataexception.printStackTrace();
	}
	MidiEvent midievent = new MidiEvent(metamessage, l);
	tracks[0].add(midievent);
    }
    
    public void read() {
	String string = MaxSystem.openDialog();
	if (string != null)
	    read(string);
    }
    
    public void read(String string) {
	tracks = null;
	try {
	    fp = new File(string);
	    sequence = MidiSystem.getSequence(fp);
	    tracks = sequence.getTracks();
	    if (tracks.length < numTracks) {
		for (int i = 0; i < numTracks - tracks.length; i++)
		    sequence.createTrack();
	    }
	    sequencer.setSequence(sequence);
	} catch (Exception exception) {
	    error(new StringBuilder().append("Couldn't read ").append
		      (string).toString());
	    return;
	}
	tracks = sequence.getTracks();
	numTracks = tracks.length;
	if (verbose)
	    postSequenceInfo();
	getInfo();
    }
    
    public void write() {
	String string = MaxSystem.saveAsDialog(new String(""), new String(""));
	if (string != null)
	    write(string);
    }
    
    public void write(String string) {
	File file = new File(string);
	try {
	    MidiSystem.write(sequence, numTracks > 1 ? 1 : 0, file);
	} catch (IOException ioexception) {
	    error(new StringBuilder().append
		      ("midifile: couldn't create file at ").append
		      (string).toString());
	    return;
	}
	post(new StringBuilder().append
		 ("midifile: successfully wrote file ").append
		 (string).toString());
    }
    
    public void play() {
	if (sequence != null)
	    sequencer.start();
    }
    
    public void play(float f) {
	if (sequence != null) {
	    sequencer.setMicrosecondPosition((long) Math.round(f * 1000.0F));
	    sequencer.start();
	}
    }
    
    public void stop() {
	if (sequencer.isRunning()) {
	    sequencer.stop();
	    sequencer.setTickPosition(0L);
	}
    }
    
    public void pause() {
	if (sequencer.isRunning())
	    sequencer.stop();
    }
    
    public void dump() {
	stop();
	if (tracks != null && tracks.length != 0) {
	    openSequencer();
	    for (int i = 0; i < tracks.length; i++) {
		for (int i_17_ = 0; i_17_ < tracks[i].size(); i_17_++) {
		    MidiEvent midievent = tracks[i].get(i_17_);
		    MidiMessage midimessage = midievent.getMessage();
		    sequencer.setTickPosition(midievent.getTick());
		    float f
			= (float) sequencer.getMicrosecondPosition() / 1000.0F;
		    if (verbose)
			post(new StringBuilder().append("status = ").append
				 (midimessage.getStatus()).toString());
		    Atom[] atoms;
		    if (midimessage.getStatus() == 255)
			atoms
			    = formatMetaMessage((MetaMessage) midimessage, f);
		    else
			atoms = formatMidiMessage(midimessage, f);
		    if (atoms != null)
			outlet(1, atoms);
		}
	    }
	    outlet(3, "bang");
	}
    }
    
    private Atom[] formatMidiMessage(MidiMessage midimessage, float f) {
	int i = midimessage.getLength();
	int i_18_ = midimessage.getStatus();
	byte[] is = midimessage.getMessage();
	if (i_18_ >= 128 && i_18_ <= 159) {
	    int i_19_ = is[1] & 0xff;
	    int i_20_ = is[2] & 0xff;
	    if (i_18_ <= 143 && ignoreNoteOffVelocity)
		i_20_ = 0;
	    int i_21_ = i_18_ <= 143 ? i_18_ - 128 : i_18_ - 144;
	    if (f == -1.0F)
		return new Atom[] { Atom.newAtom("note"), Atom.newAtom(i_19_),
				    Atom.newAtom(i_20_), Atom.newAtom(i_21_) };
	    return new Atom[] { Atom.newAtom("note"), Atom.newAtom(f),
				Atom.newAtom(i_19_), Atom.newAtom(i_20_),
				Atom.newAtom(i_21_) };
	}
	return null;
    }
    
    private Atom[] formatMetaMessage(MetaMessage metamessage, float f) {
	int i = metamessage.getType();
	byte[] is = metamessage.getData();
	post(new StringBuilder().append("type = ").append(i).toString());
	switch (i) {
	case 0:
	    return (new Atom[]
		    { Atom.newAtom("/text"), Atom.newAtom(new String(is)) });
	case 1:
	    return (new Atom[]
		    { Atom.newAtom("/text"), Atom.newAtom(new String(is)) });
	case 3: {
	    String string = new String(is);
	    post(new StringBuilder().append("META EVENT ").append(string)
		     .toString());
	    break;
	}
	case 47:
	    outlet(3, "bang");
	    break;
	case 81: {
	    float f_22_ = 6.0E7F;
	    int i_23_ = 0;
	    int i_24_ = is.length - 1;
	    int i_25_ = 0;
	    while (i_24_ >= 0) {
		i_23_ += (is[i_24_] & 0xff) << 8 * i_25_;
		i_24_--;
		i_25_++;
	    }
	    if (f == -1.0F)
		return new Atom[] { Atom.newAtom("tempo"),
				    Atom.newAtom(f_22_ / (float) i_23_) };
	    return new Atom[] { Atom.newAtom("tempo"), Atom.newAtom(f),
				Atom.newAtom(f_22_ / (float) i_23_) };
	}
	case 84:
	    post("********************");
	    post(new StringBuilder().append("timeStamp = ").append(f)
		     .toString());
	    for (int i_26_ = 0; i_26_ < is.length; i_26_++)
		post(new StringBuilder().append(i_26_).append(" ").append
			 (is[i_26_]).toString());
	    if (f == -1.0F)
		return (new Atom[]
			{ Atom.newAtom("SMPTE_offset"), Atom.newAtom(is[0]),
			  Atom.newAtom(is[1]), Atom.newAtom(is[2]),
			  Atom.newAtom(is[3]), Atom.newAtom(is[4]) });
	    return new Atom[] { Atom.newAtom("SMPTE_offset"), Atom.newAtom(f),
				Atom.newAtom(is[0]), Atom.newAtom(is[1]),
				Atom.newAtom(is[2]), Atom.newAtom(is[3]),
				Atom.newAtom(is[4]) };
	case 88:
	    if (f == -1.0F)
		return (new Atom[]
			{ Atom.newAtom("time_sig"), Atom.newAtom(is[0]),
			  Atom.newAtom(Math.pow(2.0, (double) is[1])),
			  Atom.newAtom(is[2]), Atom.newAtom(is[3]) });
	    return new Atom[] { Atom.newAtom("time_sig"), Atom.newAtom(f),
				Atom.newAtom(is[0]),
				Atom.newAtom(Math.pow(2.0, (double) is[1])),
				Atom.newAtom(is[2]), Atom.newAtom(is[3]) };
	case 89:
	    if (f == -1.0F)
		return new Atom[] { Atom.newAtom("key_sig"),
				    Atom.newAtom(is[0]), Atom.newAtom(is[1]) };
	    return new Atom[] { Atom.newAtom("key_sig"), Atom.newAtom(f),
				Atom.newAtom(is[0]), Atom.newAtom(is[1]) };
	}
	return null;
    }
    
    private void openSequencer() {
	if (!sequencer.isOpen()) {
	    try {
		sequencer.open();
	    } catch (MidiUnavailableException midiunavailableexception) {
		midiunavailableexception.printStackTrace();
	    }
	    try {
		sequencer.setSequence(sequence);
	    } catch (InvalidMidiDataException invalidmididataexception) {
		invalidmididataexception.printStackTrace();
	    }
	}
    }
    
    private void closeSequencer() {
	if (sequencer.isOpen())
	    sequencer.close();
    }
    
    public void clear() {
	stop();
	sequence = null;
	fp = null;
	initSequence();
    }
    
    private void initSequence() {
	numTracks = originalNumTracks;
	try {
	    sequence = new Sequence(0.0F, 500, numTracks);
	} catch (InvalidMidiDataException invalidmididataexception) {
	    invalidmididataexception.printStackTrace();
	}
	try {
	    sequencer = MidiSystem.getSequencer(false);
	    transmitter = sequencer.getTransmitter();
	    transmitter.setReceiver(this);
	} catch (MidiUnavailableException midiunavailableexception) {
	    midiunavailableexception.printStackTrace();
	}
	sequencer.addMetaEventListener(this);
	try {
	    sequencer.setSequence(sequence);
	} catch (InvalidMidiDataException invalidmididataexception) {
	    invalidmididataexception.printStackTrace();
	}
	openSequencer();
	sequencer.setTempoInBPM(120.0F);
	tracks = sequence.getTracks();
    }
    
    public void postSequenceInfo() {
	post(new StringBuilder().append("divisionType = ").append
		 (sequence.getDivisionType()).toString());
	post(new StringBuilder().append("resolution = ").append
		 (sequence.getResolution()).toString());
	post(new StringBuilder().append("microsecondLength = ").append
		 (sequence.getMicrosecondLength()).toString());
	post(new StringBuilder().append("tickLength = ").append
		 (sequence.getTickLength()).toString());
    }
    
    public void tellmeeverything() {
	post("**************************************************");
	post(new StringBuilder().append("sequence has ").append
		 (tracks.length).append
		 (" track(s)").toString());
	post("");
	for (int i = 0; i < tracks.length; i++)
	    post(new StringBuilder().append("track ").append(i).append
		     (" has ").append
		     (tracks[i].size()).append
		     (" events").toString());
	post("");
	post("Sequence info:");
	postSequenceInfo();
	post("");
	post(new StringBuilder().append("sequencer is ").append
		 (sequencer.isRunning() ? "" : "not").append
		 (" running").toString());
	post(new StringBuilder().append("sequencer is ").append
		 (sequencer.isOpen() ? "open" : "closed").toString());
	post("**************************************************");
    }
    
    public void getInfo() {
	if (fp != null) {
	    try {
		outlet(2, new Atom[] { Atom.newAtom("/filepath"),
				       Atom.newAtom(fp.getCanonicalPath()) });
	    } catch (Exception exception) {
		exception.printStackTrace();
	    }
	} else
	    outlet(2,
		   new Atom[] { Atom.newAtom("/filepath"), Atom.newAtom("") });
	outlet(2, (new Atom[]
		   { Atom.newAtom("/duration"),
		     Atom.newAtom((float) sequencer.getMicrosecondLength()
				  / 1000.0F) }));
	outlet(2, new Atom[] { Atom.newAtom("/numTracks"),
			       Atom.newAtom(tracks.length) });
	sequencer.setTickPosition(sequencer.getLoopStartPoint());
	long l = sequencer.getMicrosecondPosition() / 1000L;
	sequencer.setTickPosition(sequencer.getLoopEndPoint());
	long l_27_ = sequencer.getMicrosecondPosition() / 1000L;
	long l_28_ = (long) sequencer.getLoopCount();
	outlet(2, new Atom[] { Atom.newAtom("/loop/start"), Atom.newAtom(l) });
	outlet(2,
	       new Atom[] { Atom.newAtom("/loop/end"), Atom.newAtom(l_27_) });
	outlet(2, new Atom[] { Atom.newAtom("/loop/count"),
			       Atom.newAtom(l_28_) });
    }
    
    public void mute(int i, int i_29_) {
	sequencer.setTrackMute(i, i_29_ != 0);
    }
    
    public void solo(int i, int i_30_) {
	sequencer.setTrackSolo(i, i_30_ != 0);
    }
    
    public void setTempoFactor(float f) {
	sequencer.setTempoFactor(f);
    }
    
    public void setLoop(int i, int i_31_) {
	setLoop(i, i_31_, -1);
    }
    
    public void setLoop(int i, int i_32_, int i_33_) {
	sequencer.setMicrosecondPosition((long) (i * 1000));
	sequencer.setLoopStartPoint(sequencer.getTickPosition());
	sequencer.setMicrosecondPosition((long) (i_32_ * 1000));
	sequencer.setLoopEndPoint(sequencer.getTickPosition());
	sequencer.setLoopCount(i_33_);
    }
    
    public void setLoopStart(int i) {
	sequencer.setMicrosecondPosition((long) (i * 1000));
	sequencer.setLoopStartPoint(sequencer.getTickPosition());
    }
    
    public void setLoopEnd(int i) {
	sequencer.setMicrosecondPosition((long) (i * 1000));
	sequencer.setLoopEndPoint(sequencer.getTickPosition());
    }
    
    public void setLoopCount(int i) {
	sequencer.setLoopCount(i);
    }
    
    public void setDefaultDuration(int i) {
	def_duration = i;
    }
    
    public void setDefaultChannel(int i) {
	def_channel = i;
    }
    
    public void setDefaultVelocity(int i) {
	def_velocity = i;
    }
    
    public void verbose(boolean bool) {
	verbose = bool;
    }
    
    public void ignoreNoteOffVelocity(int i) {
	ignoreNoteOffVelocity = i != 0;
    }
    
    public void notifyDeleted() {
	sequencer.stop();
	sequencer.close();
	transmitter.close();
    }
    
    public void close() {
	/* empty */
    }
    
    public void send(MidiMessage midimessage, long l) {
	Atom[] atoms = formatMidiMessage(midimessage, -1.0F);
	if (midimessage != null && atoms != null)
	    outlet(0, atoms);
    }
    
    public void meta(MetaMessage metamessage) {
	Atom[] atoms = formatMetaMessage(metamessage, -1.0F);
	if (metamessage != null && atoms != null)
	    outlet(0, atoms);
    }
}
